## crunch-dxtc 0.55.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(CMAKE_CXX_STANDARD 11)

set(CRUNCH_PROJECT_NAME crunch)
set(CRUNCH_LIBRARY_NAME crn)
set(CRUNCH_EXE_NAME crunch)

project(${CRUNCH_PROJECT_NAME} LANGUAGES CXX)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE "Release" CACHE
		STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel" FORCE)
endif()

find_package(Git)

if (Git_FOUND)
	execute_process(
		COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
		WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
		OUTPUT_VARIABLE GIT_VERSION
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)

	if (GIT_VERSION)
		add_definitions(-DCOMPUTED_VERSION_SUFFIX="Built from git-${GIT_VERSION}")
	endif()
endif()

macro(set_cxx_flag FLAG)
	if (${ARGC} GREATER 1)
		set(CMAKE_CXX_FLAGS_${ARGV1} "${CMAKE_CXX_FLAGS_${ARGV1}} ${FLAG}")
	else()
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${FLAG}")
	endif()
endmacro()

macro(set_linker_flag FLAG)
	if (${ARGC} GREATER 1)
		set(CMAKE_EXE_LINKER_FLAGS_${ARGV1} "${CMAKE_EXE_LINKER_FLAGS_${ARGV1}} ${FLAG}")
		set(CMAKE_SHARED_LINKER_FLAGS_${ARGV1} "${CMAKE_SHARED_LINKER_FLAGS_${ARGV1}} ${FLAG}")
		set(CMAKE_MODULE_LINKER_FLAGS_${ARGV1} "${CMAKE_MODULE_LINKER_FLAGS_${ARGV1}} ${FLAG}")
	else()
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${FLAG}")
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${FLAG}")
		set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${FLAG}")
	endif()
endmacro()

# This option decides if crunch is dynamically linked against libcrn.so
# statically linked against libcrn.o, enabling it always build libcrn.so.
# This option is a builtin CMake one, the name means “build executables
# against shader libraries”, not “build the shared libraries”.
option(BUILD_SHARED_LIBS "Link executables against shared library" OFF)
# Always build libcrn.so even if crunch is linked to libcrn statically.
option(BUILD_SHARED_LIBCRN "Build shared libcrn" OFF)
# Always build libcrn.a even if crunch is linked to libcrn dynamically.
option(BUILD_STATIC_LIBCRN "Build static libcrn" OFF)
# Build the crunch tool, implies the build of libcrn.o or libcrn.so.
option(BUILD_CRUNCH "Build crunch" ON)
# Build the provided examples, they only build on Windows for now.
option(BUILD_EXAMPLES "Build examples" OFF)
# Enable extra optimization flags, like using -O3 even in RelWithDebInfo build.
option(USE_EXTRA_OPTIMIZATION "Enable extra optimization" ON)
# Enable link time optimization, slows down the build but produce faster and smaller binaries.
option(USE_LTO "Enable link-time optimization" OFF)
# Enabling fast math makes generated images less likely to be reproducible.
# See https://github.com/DaemonEngine/crunch/issues/29
option(USE_FAST_MATH "Enable fast math (generated images are less likely to be reproducible)" OFF)

if (BUILD_STATIC_LIBCRN)
	option(INSTALL_STATIC_LIBCRN "Install static libraries" OFF)
endif()

if (MSVC)
	# Enable MSVC parallel compilation.
	set_cxx_flag("/MP")

	# MSVC doesn't implement strict aliasing so there is nothing else to do.
	
	# CMake already sets the /O2 flag on Release and RelWithDebInfo build and /O[1-2] already sets the /Oy flag.

	if (USE_FAST_MATH)
		# By default, the MSVC /fp:fast option enables /fp:contract (introduced in VS 2022).
		# See https://learn.microsoft.com/en-us/cpp/build/reference/fp-specify-floating-point-behavior
		# and https://devblogs.microsoft.com/cppblog/the-fpcontract-flag-and-changes-to-fp-modes-in-vs2022/
		# By default, MSVC doesn't enable the /fp:fast option.
		set_cxx_flag("/fp:fast")
	endif()

	if (USE_LTO)
		set_cxx_flag("/GL" RELEASE)
		set_cxx_flag("/GL" RELWITHDEBINFO)
		set_cxx_flag("/GL" MINSIZEREL)
		set_linker_flag("/LTCG" RELEASE)
		set_linker_flag("/LTCG" RELWITHDEBINFO)
		set_linker_flag("/LTCG" MINSIZEREL)
	endif()
else()
	# As written in crnlib.h and stb_image.h, strict aliasing should always be disabled.
	set_cxx_flag("-fno-strict-aliasing")

	# Generate maxmimum amount of debug information, including macro definitions.
	set_cxx_flag("-g3" DEBUG)
	set_cxx_flag("-g3" RELWITHDEBINFO)

	set_cxx_flag("-pthread")
	set_linker_flag("-pthread")

	if (USE_EXTRA_OPTIMIZATION)
		# CMake already sets the -O3 flag on Release build and -O[1-3s] already sets the -fomit-frame-pointer flag.
		set_cxx_flag("-Og" DEBUG)
		set_cxx_flag("-O3" RELWITHDEBINFO)
	endif()

	if (USE_FAST_MATH)
		# By default, GCC uses -ffp-contract=fast with -std=gnu* and uses -ffp-contract=off with -std=c*.
		# See https://gcc.gnu.org/onlinedocs/gcc/Optimize-Options.html
		# By default, GCC doesn't enable the -ffast-math option.
		set_cxx_flag("-ffast-math -fno-math-errno -ffp-contract=fast")
	else()
		# By default, GCC uses -std=gnu* and then enables -ffp-contract=fast even if -ffast-math is not enabled.
		set_cxx_flag("-ffp-contract=off")
	endif()

	# It should be done at the very end because it copies all compiler flags
	# to the linker flags.
	if (USE_LTO)
		set_cxx_flag("-flto" RELEASE)
		set_cxx_flag("-flto" RELWITHDEBINFO)
		set_cxx_flag("-flto" MINSIZEREL)
		set_linker_flag("${CMAKE_CXX_FLAGS}" RELEASE)
		set_linker_flag("${CMAKE_CXX_FLAGS}" RELWITHDEBINFO)
		set_linker_flag("${CMAKE_CXX_FLAGS}" MINSIZEREL)
	endif()
endif()

if (BUILD_SHARED_LIBCRN OR BUILD_STATIC_LIBCRN OR BUILD_CRUNCH OR BUILD_EXAMPLES)
	add_subdirectory(crnlib crnlib)
endif()

if (BUILD_CRUNCH)
	add_subdirectory(crunch _crunch)
endif()

if (BUILD_EXAMPLES)
	add_subdirectory(example1 _example1)
	add_subdirectory(example2 _example2)
	add_subdirectory(example3 _example3)
endif()

=== crnlib/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc
)

# Defines the source code for the library
set(CRNLIB_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_arealist.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_arealist.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_assert.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_assert.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_buffer_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_cfile_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_checksum.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_checksum.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_clusterizer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_color.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_colorized_console.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_colorized_console.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_command_line_params.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_command_line_params.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_comp.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_comp.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_console.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_console.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_core.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_core.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_data_stream.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_data_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_data_stream_serializer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dds_comp.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dds_comp.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_decomp.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt1.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt1.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt5a.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt5a.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_endpoint_refiner.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_endpoint_refiner.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_fast.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_fast.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_hc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_hc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_hc_common.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_hc_common.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_image.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dxt_image.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dynamic_stream.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dynamic_string.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_dynamic_string.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_etc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_etc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_file_utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_file_utils.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_find_files.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_find_files.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_hash.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_hash.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_hash_map.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_hash_map.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_helpers.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_huffman_codes.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_huffman_codes.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_image.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_image_utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_image_utils.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_intersect.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_jpgd.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_jpgd.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_jpge.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_jpge.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_ktx_texture.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_ktx_texture.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_lzma_codec.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_lzma_codec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_math.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_math.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_matrix.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_mem.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_mem.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_miniz.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_miniz.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_mipmapped_texture.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_mipmapped_texture.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_packed_uint.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_pixel_format.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_pixel_format.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_platform.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_platform.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_prefix_coding.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_prefix_coding.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_qdxt1.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_qdxt1.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_qdxt5.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_qdxt5.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_rand.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_rand.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_ray.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_rect.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_resample_filters.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_resample_filters.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_resampler.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_resampler.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_rg_etc1.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_rg_etc1.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_ryg_dxt.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_ryg_dxt.hpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_ryg_types.hpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_sparse_array.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_sparse_bit_array.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_sparse_bit_array.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_stb_image.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_strutils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_strutils.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_symbol_codec.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_symbol_codec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_texture_comp.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_texture_comp.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_texture_conversion.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_texture_conversion.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_texture_file_types.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_texture_file_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_threaded_clusterizer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_threaded_resampler.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_threaded_resampler.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_threading.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_threading_null.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_timer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_timer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_traits.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_tree_clusterizer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_utils.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_value.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_value.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_vec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_vec_interval.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_vector.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_vector.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_vector2d.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crn_winhdr.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crnlib.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zBuf.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zBuf.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zBuf2.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zCrc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zFile.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zFile.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zStream.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_7zVersion.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Alloc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Alloc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Bcj2.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Bcj2.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Bra.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Bra.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Bra86.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_BraIA64.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_CpuArch.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzFind.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzFind.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzHash.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzmaDec.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzmaDec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzmaEnc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzmaEnc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzmaLib.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzmaLib.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_MyVersion.h
  ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Types.h
  ${CMAKE_CURRENT_SOURCE_DIR}/stb_image.h
  ${CMAKE_CURRENT_SOURCE_DIR}/stb_image_write.h
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc/crn_decomp.h
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc/crnlib.h
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc/dds_defs.h
)

if(WIN32)
  set(CRNLIB_THREAD_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzFindMt.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lzma_LzFindMt.h
    ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Threads.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lzma_Threads.h
    ${CMAKE_CURRENT_SOURCE_DIR}/crn_threading_win32.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/crn_threading_win32.h
  )
else()
  set(CRNLIB_THREAD_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/crn_threading_pthreads.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/crn_threading_pthreads.h
  )
endif()

set(CRUNCH_OBJECT_NAME ${CRUNCH_LIBRARY_NAME}-obj)
add_library(${CRUNCH_OBJECT_NAME} OBJECT ${CRNLIB_SRCS} ${CRNLIB_THREAD_SRCS})
set_property(TARGET ${CRUNCH_OBJECT_NAME} PROPERTY POSITION_INDEPENDENT_CODE 1)

if(BUILD_SHARED_LIBS)
  set(CRUNCH_DEFAULT_LIBRARY_TYPE SHARED)
  set(CRUNCH_OTHER_LIBRARY_TYPE STATIC)
  set(CRUNCH_OTHER_LIBRARY_SUFFIX -static)
else()
  set(CRUNCH_DEFAULT_LIBRARY_TYPE STATIC)
  set(CRUNCH_OTHER_LIBRARY_TYPE SHARED)
  set(CRUNCH_OTHER_LIBRARY_SUFFIX -shared)
endif()

add_library(${CRUNCH_LIBRARY_NAME} ${CRUNCH_DEFAULT_LIBRARY_TYPE} $<TARGET_OBJECTS:${CRUNCH_OBJECT_NAME}>)
set_property(TARGET ${CRUNCH_LIBRARY_NAME} PROPERTY POSITION_INDEPENDENT_CODE 1)

if (BUILD_SHARED_LIBS OR (BUILD_STATIC_LIBCRN AND INSTALL_STATIC_LIBCRN))
  install(TARGETS ${CRUNCH_LIBRARY_NAME} DESTINATION lib)
endif()

if ((BUILD_SHARED_LIBS AND BUILD_STATIC_LIBCRN) OR (NOT BUILD_SHARED_LIBS AND BUILD_SHARED_LIBCRN))
  set(CRUNCH_OTHER_LIBRARY_NAME ${CRUNCH_LIBRARY_NAME}${CRUNCH_OTHER_LIBRARY_SUFFIX})

  add_library(${CRUNCH_OTHER_LIBRARY_NAME} ${CRUNCH_OTHER_LIBRARY_TYPE} $<TARGET_OBJECTS:${CRUNCH_OBJECT_NAME}>)
  set_property(TARGET ${CRUNCH_OTHER_LIBRARY_NAME} PROPERTY POSITION_INDEPENDENT_CODE 1)

  if(NOT WIN32)
    set_target_properties(${CRUNCH_OTHER_LIBRARY_NAME} PROPERTIES OUTPUT_NAME ${CRUNCH_LIBRARY_NAME})
  endif()

  install(TARGETS ${CRUNCH_OTHER_LIBRARY_NAME} DESTINATION lib)
endif()

=== crnlib/Makefile ===
.DEFAULT_GOAL := all
.PHONY: all clean

CXX = g++

COMPILE_CPU_OPTIONS = -march=core2
COMPILE_DEBUG_OPTIONS = -g
COMPILE_OPTIMIZATION_OPTIONS = -O3 -fomit-frame-pointer -ffast-math -fno-math-errno -fno-strict-aliasing
COMPILE_WARN_OPTIONS = -Wall -Wno-unused-value -Wno-unused
COMPILE_OPTIONS = -std=c++11 $(COMPILE_CPU_OPTIONS) $(COMPILE_DEBUG_OPTIONS) $(COMPILE_OPTIMIZATION_OPTIONS) $(COMPILE_WARN_OPTIONS)

LINKER_OPTIONS = -lpthread -g

OBJECTS = \
  crn_arealist.o \
  crn_assert.o \
  crn_checksum.o \
  crn_colorized_console.o \
  crn_command_line_params.o \
  crn_comp.o \
  crn_console.o \
  crn_core.o \
  crn_data_stream.o \
  crn_mipmapped_texture.o \
  crn_decomp.o \
  crn_dxt1.o \
  crn_dxt5a.o \
  crn_dxt.o \
  crn_dxt_endpoint_refiner.o \
  crn_dxt_fast.o \
  crn_dxt_hc_common.o \
  crn_dxt_hc.o \
  crn_dxt_image.o \
  crn_dynamic_string.o \
  crn_file_utils.o \
  crn_find_files.o \
  crn_hash.o \
  crn_hash_map.o \
  crn_huffman_codes.o \
  crn_image_utils.o \
  crnlib.o \
  crn_math.o \
  crn_mem.o \
  crn_pixel_format.o \
  crn_platform.o \
  crn_prefix_coding.o \
  crn_qdxt1.o \
  crn_qdxt5.o \
  crn_rand.o \
  crn_resample_filters.o \
  crn_resampler.o \
  crn_ryg_dxt.o \
  crn_sparse_bit_array.o \
  crn_stb_image.o \
  crn_strutils.o \
  crn_symbol_codec.o \
  crn_texture_file_types.o \
  crn_threaded_resampler.o \
  crn_threading_pthreads.o \
  crn_timer.o \
  crn_utils.o \
  crn_value.o \
  crn_vector.o \
  crn_texture_comp.o \
  crn_texture_conversion.o \
  crn_dds_comp.o \
  crn_lzma_codec.o \
  crn_ktx_texture.o \
  crn_etc.o \
  crn_rg_etc1.o \
  crn_miniz.o \
  crn_jpge.o \
  crn_jpgd.o \
  lzma_7zBuf2.o \
  lzma_7zBuf.o \
  lzma_7zCrc.o \
  lzma_7zFile.o \
  lzma_7zStream.o \
  lzma_Alloc.o \
  lzma_Bcj2.o \
  lzma_Bra86.o \
  lzma_Bra.o \
  lzma_BraIA64.o \
  lzma_LzFind.o \
  lzma_LzmaDec.o \
  lzma_LzmaEnc.o \
  lzma_LzmaLib.o

all: crunch

%.o: %.cpp
	$(CXX) $< -o $@ -c $(COMPILE_OPTIONS)

crunch.o: ../crunch/crunch.cpp
	$(CXX) $< -o $@ -c -I../inc -I../crnlib $(COMPILE_OPTIONS)

corpus_gen.o: ../crunch/corpus_gen.cpp
	$(CXX) $< -o $@ -c -I../inc -I../crnlib $(COMPILE_OPTIONS)

corpus_test.o: ../crunch/corpus_test.cpp
	$(CXX) $< -o $@ -c -I../inc -I../crnlib $(COMPILE_OPTIONS)

crunch: $(OBJECTS) crunch.o corpus_gen.o corpus_test.o
	$(CXX) $(OBJECTS) crunch.o corpus_gen.o corpus_test.o -o crunch $(LINKER_OPTIONS)

clean:
	rm $(OBJECTS) crunch.o corpus_gen.o corpus_test.o crunch

=== crunch/CMakeLists.txt ===
find_package (Threads)

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc
  ${CMAKE_CURRENT_SOURCE_DIR}/../crnlib
)

# Defines the source code for the library
set(CRUNCH_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/corpus_gen.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/corpus_gen.h
  ${CMAKE_CURRENT_SOURCE_DIR}/corpus_test.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/corpus_test.h
  ${CMAKE_CURRENT_SOURCE_DIR}/crunch.cpp
)

add_executable(${CRUNCH_EXE_NAME} ${CRUNCH_SRCS})

target_link_libraries(${CRUNCH_EXE_NAME} ${CRUNCH_LIBRARY_NAME} ${CMAKE_THREAD_LIBS_INIT})

install(TARGETS ${CRUNCH_EXE_NAME} DESTINATION bin)
set_property(TARGET ${CRUNCH_EXE_NAME} PROPERTY POSITION_INDEPENDENT_CODE 1)

=== emscripten/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(CMAKE_CXX_STANDARD 11)

set(CRUNCHJS_EXE_NAME crunch)

if (NOT CMAKE_CXX_COMPILER)
	set(CMAKE_CXX_COMPILER emcc)
endif()

project(${CRUNCHJS_EXE_NAME}.js LANGUAGES CXX)

if (NOT CMAKE_TOOLCHAIN_FILE)
	set(CMAKE_EXECUTABLE_SUFFIX .js)
endif()

set(CMAKE_CXX_FLAGS "-O3 ${CMAKE_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -s EXPORTED_FUNCTIONS=\"['_malloc', '_free', '_crn_get_width', '_crn_get_height', '_crn_get_levels', '_crn_get_dxt_format', '_crn_get_bytes_per_block', '_crn_get_uncompressed_size', '_crn_decompress']\" -s NO_EXIT_RUNTIME=1 -s NO_FILESYSTEM=1 -s ELIMINATE_DUPLICATE_FUNCTIONS=1 -s ALLOW_MEMORY_GROWTH=1 --memory-init-file 0")

include_directories(
	${CMAKE_CURRENT_SOURCE_DIR}/../inc
)

set(CRUNCHJS_SRCS
	${CMAKE_CURRENT_SOURCE_DIR}/crunch_lib.cpp
)

add_executable(${CRUNCHJS_EXE_NAME} ${CRUNCHJS_SRCS})

=== emscripten/Makefile ===
.DEFAULT_GOAL := all
.PHONY: all clean

CXX = emcc

COMPILE_OPTIMIZATION_OPTIONS = -O3
COMPILE_OPTIONS = -std=c++11 ${COMPILE_OPTIMIZATION_OPTIONS}

LINKER_OPTIONS = -s EXPORTED_FUNCTIONS="['_malloc', '_free', '_crn_get_width', '_crn_get_height', '_crn_get_levels', '_crn_get_dxt_format', '_crn_get_bytes_per_block', '_crn_get_uncompressed_size', '_crn_decompress']" -s NO_EXIT_RUNTIME=1 -s NO_FILESYSTEM=1 -s ELIMINATE_DUPLICATE_FUNCTIONS=1 -s ALLOW_MEMORY_GROWTH=1 --memory-init-file 0

all: crunch.js

crunch.js: crunch_lib.cpp
	$(CXX) $< -o $@ -I../inc $(COMPILE_OPTIONS) $(LINKER_OPTIONS)

clean:
	rm crunch.js crunch.wasm

=== example1/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc
  ${CMAKE_CURRENT_SOURCE_DIR}/../crnlib
)

# Defines the source code for the library
set(EXAMPLE1_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/example1.cpp
)

add_executable(example1 ${EXAMPLE1_SRCS})
target_link_libraries(example1 ${CRUNCH_LIBRARY_NAME})

=== example2/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc
  ${CMAKE_CURRENT_SOURCE_DIR}/../crnlib
)

# Defines the source code for the library
set(EXAMPLE2_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/example2.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/timer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/timer.h
)

add_executable(example2 ${EXAMPLE2_SRCS})
target_link_libraries(example2 ${CRUNCH_LIBRARY_NAME})

=== example3/CMakeLists.txt ===
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/../inc
  ${CMAKE_CURRENT_SOURCE_DIR}/../crnlib
)

# Defines the source code for the library
set(EXAMPLE3_SRCS
  ${CMAKE_CURRENT_SOURCE_DIR}/example3.cpp
)

add_executable(example3 ${EXAMPLE3_SRCS})
target_link_libraries(example3 ${CRUNCH_LIBRARY_NAME})

=== debian/changelog ===
crunch-dxtc (0.55.5-1) unstable; urgency=medium

  * Initial release.  (Closes: #1110428)

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 22 Oct 2025 10:34:46 +0200

=== debian/control ===
Source: crunch-dxtc
Section: graphics
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13), cmake
Standards-Version: 4.7.2
Homepage: https://github.com/DaemonEngine/crunch
Vcs-Browser: https://salsa.debian.org/twolife/crunch-dxtc
Vcs-Git: https://salsa.debian.org/twolife/crunch-dxtc.git

Package: crunch-dxtc
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Advanced DXTc texture compression and transcoding tool
 crunch is an open source lossy texture compression command line
 tool for developers that distribute and use content in the DXT1/5/N or
 3DC/BC5 compressed mipmapped GPU texture formats.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

execute_after_dh_auto_install:
	mv debian/crunch-dxtc/usr/bin/crunch debian/crunch-dxtc/usr/bin/crunch-dxtc

=== debian/watch ===
Version: 5
Template: Github
Owner: DaemonEngine
Project: crunch
Matching-Pattern: https://api.github.com/repos/DaemonEngine/crunch/git/refs/tags/unvanquished/@ANY_VERSION@
